const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const product_brush_kits = sequelize.define(
    'product_brush_kits',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

kit_name: {
        type: DataTypes.TEXT,
      
      

      },

brush_count: {
        type: DataTypes.INTEGER,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  product_brush_kits.associate = (db) => {

    db.product_brush_kits.belongsToMany(db.brush_types, {
      as: 'brushes',
      foreignKey: {
        name: 'product_brush_kits_brushesId',
      },
      constraints: false,
      through: 'product_brush_kitsBrushesBrush_types',
    });

    db.product_brush_kits.belongsToMany(db.brush_types, {
      as: 'brushes_filter',
      foreignKey: {
        name: 'product_brush_kits_brushesId',
      },
      constraints: false,
      through: 'product_brush_kitsBrushesBrush_types',
    });


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




























//end loop



    db.product_brush_kits.belongsTo(db.products, {
      as: 'product',
      foreignKey: {
        name: 'productId',
      },
      constraints: false,
    });




    db.product_brush_kits.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.product_brush_kits.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return product_brush_kits;
};


